/* ystestCli.c: TCP/IP NCAgTvvO		*/
/* Copyright (c) yma system lab. 2006						*/
#include <windows.h>
#include <stdio.h>
#include "ystcpApi.h"

#define	CONNECT_TIME	10
#define	RECV_TIME		30

char* sendRecv(char *cltcp, char *msg, int sendlen, int *recvlen);

int main(int argc, char** argv) {
	char		host[64];
	int			port		= 0;
	int			concounts	= 0;
	int			sendcounts	= 0;
	char		*cltcp		= NULL;
	int			error		= 0;
	char		*sendmsg	= "testmsg:1234567890abcdefghijklmnopqrstuvwxyz";
	char		*recvmsg	= NULL;
	char		*endmsg		= "end";
	int			sendlen		= 0;
	int			recvlen		= 0;	
	int			i			= 0;
	int			j			= 0;

	if (argc < 5) {
		printf("command: ystestCli host port accept_counts send_counts\n");
		return 1;
	}
	strcpy(host, argv[1]);										/* zXg擾		*/
	port = atoi(argv[2]);										/* portԍ擾		*/
	concounts = atoi(argv[3]);									/* ڑ񐔂擾		*/
	sendcounts = atoi(argv[4]);									/* M񐔂擾		*/

    if ((error = tcpLoadLib()) != 0) {							/* DLL̃[fBO	*/
		printf("tcpLoadLib()ُI܂Bcode(%d)\n", error);
		return 1;
	}
	if ((cltcp = tcpClInit(32*1024,
					"ystcplog", "tcpCli.txt", 2)) <= 0) error = -1;/* NCAg*/

	for(i = 0; (error == 0) && (i < concounts); i++) {			/* ڑ񐔂JԂ		*/
		if (tcpClConnect(cltcp, host, port, CONNECT_TIME) != 0) {/* T[o[Ɛڑ		*/
			tcpLogError(cltcp, "tcpClConnect()ŃG[܂, port", port);
			error = -2;
			break;
		}
		for(j = 0;(error == 0) && (j < sendcounts); j++) {		/* M񐔂JԂ		*/
			sendlen = (int)strlen(sendmsg) + 1;
			if ((recvmsg = sendRecv(cltcp, sendmsg, sendlen, &recvlen)) == NULL) error = -3;
			else if (strcmp(sendmsg, recvmsg) != 0) {			/* MMf[^r	*/
				printf("%d.%d_%s NG\n", i, j, recvmsg);			/* Mf[^\(NG)	*/
				error = -4;
			}
			else printf("%d.%d_%s OK\n", i, j, recvmsg);		/* Mf[^\(OK)	*/
		}
		sendlen = (int)strlen(endmsg) + 1;						/* endbZ[W𑗐M	*/
		if (sendRecv(cltcp, endmsg, sendlen, &recvlen) == NULL) error = -5;
		tcpClDisconnect(cltcp);									/* ڑJ			*/
	}
	tcpClTerm(cltcp);											/*NCAg*/
	cltcp	= NULL;
	tcpFreeLib();

    return error;
}
char* sendRecv(char *cltcp, char *msg, int sendlen, int *recvlen) {
	char	*retmsg	= NULL;

	if (tcpClSend(cltcp, msg, sendlen) != 0) {
		tcpLogError(cltcp, "clSend()ŃG[܂, length", sendlen);
	}
	else if ((retmsg = tcpClRecv(cltcp, RECV_TIME, recvlen)) == NULL) {
		tcpLogError(cltcp, "clRecv()ŃG[܂, code", *recvlen);
	}
	return retmsg;
}
