/* ystestSvr.c: TCP/IP T[o[TvvO	*/
/* Copyright (c) yma system lab. 2006				*/
#include <windows.h>
#include <stdio.h>
#include "ystcpApi.h"

#define	RECV_TIME		30
#define	MAX_THREADS		10

void testThread(char *actcp);
int  actThread(char *actcp);
void threadProc(LPVOID);

HANDLE	hThread[MAX_THREADS];

int main(int argc, char** argv) {
	int			port		= 0;
	char		*svtcp		= NULL;
	char		*actcp		= NULL;
	int			error		= 0;
	char		*senderror	= "over the max threads";
	int			i			= 0;
	int			recvlen		= 0;

	for(i = 0; i < MAX_THREADS; i++) {
		hThread[i] = NULL;
	}
	if (argc < 2) {
		printf("command: ystestSvr port\n");
		return 1;
	}
	port = atoi(argv[1]);

    if ((error = tcpLoadLib()) != 0) {							/* DLL̃[fBO	*/
		printf("tcpLoadLib()ُI܂Bcode(%d)\n", error);
		return 1;
	}
	if ((svtcp = tcpSvInit(port, 32*1024,
					"ystcplog", "tcpSvr.txt", 2)) <= 0) error = -1;/* T[o[̏	*/

	while(error == 0) {
		if ((actcp = tcpSvAccept(svtcp)) == NULL) {
			error = -1;
			printf("tcpSvAcceptňُ킪܂\n"); 
			tcpLogError(svtcp, "tcpSvAccept()ňُ킪܂B", error);
		}
		else {
			testThread(actcp);									/* XbhIeXg	*/
			if (actThread(actcp) != 0) {						/* XbhNɎs	*/
				tcpSvRecv(actcp, RECV_TIME, &recvlen);			/* f[^̎M(ǎ̂)	*/
				tcpSvSend(actcp, senderror, strlen(senderror)+1);/* G[bZ[WM*/
				tcpSvClose(actcp);								/* accept̉		*/
				actcp = NULL;
			}
		}
	}
	tcpSvTerm(svtcp);											/* T[o[̊J	*/
	svtcp	= NULL;
	tcpFreeLib();												/* DLL̊J			*/

    return error;
}
void testThread(char *actcp) {
	int		i			= 0;
	int		exitCode	= 0;
	char	msg[512];

	for(i = 0; i < MAX_THREADS; i++) {
		if (hThread[i] == NULL) continue;

		GetExitCodeThread(hThread[i], &exitCode);			/* XbhIR[h擾	*/
		if (exitCode == STILL_ACTIVE) continue;				/* Xbh쒆̔	*/

		sprintf(msg, "Xbh̏I, thread(%d), code", (int)hThread[i]);
		tcpLogInfo(actcp, msg, exitCode);					/* XbhIbZ[W	*/
		CloseHandle(hThread[i]);							/* nhN[Y		*/
		hThread[i] = NULL;									/* Gg󂫂ɂ		*/
	}
}
int actThread(char *actcp) {
	int		retcode		= 0;
	int		i			= 0;
	int		threadId	= 0;

	for(i = 0; i < MAX_THREADS; i++) {
		if (hThread[i] != NULL) continue;					/* 󂫃GgT		*/
		hThread[i] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)threadProc,
										 (LPVOID)actcp, 0, &threadId);
		if (hThread[i] == NULL) {
			tcpLogError(actcp, "XbhNG[, code", GetLastError());
			retcode = -1;									/* Xbh쐬G[		*/
		}
		else {
			tcpLogInfo(actcp, "XbhN, thread", (int)hThread[i]);
		}
		break;
	}
	if ( i >= MAX_THREADS) {
		tcpLogError(actcp, "Xbhől𒴂܂, thread counts", i);
		retcode = -2;
	}
	return retcode;
}
void threadProc(LPVOID parm) {
	int		error		= 0;
	char	*recvmsg	= NULL;
	char	*endmsg		= "end";
	char	*termmsg	= "term";
	int		recvlen		= 0;
	int		counts		= 0;
	char	*actcp		= (char *)parm;

	while(error == 0) {
		counts++;
		if ((recvmsg = tcpSvRecv(actcp, RECV_TIME, &recvlen)) == NULL) {/* f[^M	*/
			tcpLogError(actcp, "svRecv()ňُ킪܂, code", recvlen);
			error = -10;
		}
		else {
//			T[o[{܂B
//@@@@@FR}hsȂ"system(recvmsg+n)"
//				t@Co͂Ȃ"open(),write(),close()
//				ȂǎRȏLqł܂AXbhZCt̊֐𗘗pKv܂B
//
//		@@@@eXgł͒PɎMf[^ԐMB
			if (tcpSvSend(actcp, recvmsg, recvlen) != 0) {		/* f[^̕ԐM			*/
				tcpLogError(actcp, "svSend()ňُ킪܂, length", recvlen);
				error = -11;
			}
			else if (strcmp(recvmsg, endmsg) == 0) break;		/* endbZ[W̔	*/
		}
	}
	tcpSvClose(actcp);											/* accept̉		*/
	ExitThread(error);											/* Xbh̏I		*/
}
